'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _spmLog = require('spm-log');

var _spmLog2 = _interopRequireDefault(_spmLog);

var _path = require('path');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { return step("next", value); }, function (err) { return step("throw", err); }); } } return step("next"); }); }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function fetchOne(record, local, autoPick) {
  var langs = Object.keys(record);
  var result = record;
  langs.forEach(function (lang) {
    if (local[lang] && local[lang][record.id]) {
      if (autoPick === 'local' || autoPick === true) {
        _spmLog2.default.info('using local ' + record.id + ':' + lang, local[lang][record.id]);
        result[lang] = local[lang][record.id];
      } else if (!isNaN(parseInt(autoPick, 10))) {
        var index = Object.keys(result[lang])[parseInt(autoPick, 10)];
        _spmLog2.default.info('using ' + parseInt(autoPick, 10) + 'th ' + record.id, result[lang][index]);
        result[lang] = result[lang][index];
      } else if (record[lang].constructor === Object) {
        var des = local[lang][record.id] + ' - from local';
        result[lang][des] = local[lang][record.id];
      } else if (typeof record[lang] === 'string') {
        var _result$lang;

        var _des = local[lang][record.id] + ' - from local';
        result[lang] = (_result$lang = {}, _defineProperty(_result$lang, result[lang], result[lang]), _defineProperty(_result$lang, _des, local[lang][record.id]), _result$lang);
      }
    }
  });
  return record;
}

function exists(path) {
  try {
    require.resolve(path);
  } catch (e) {
    return false;
  }
  return true;
}

function fetchLocal(result, local, autoPick) {
  return result.map(function (item) {
    return fetchOne(item, local, autoPick);
  });
}

exports.default = function () {
  var ref = _asyncToGenerator(regeneratorRuntime.mark(function _callee(result, query, context) {
    var pickResource, _autoPick$query, autoPick, local, select, isObject, maxKeys, file, _iteratorNormalCompletion, _didIteratorError, _iteratorError, _iterator, _step, item, langs, _iteratorNormalCompletion2, _didIteratorError2, _iteratorError2, _iterator2, _step2, lang;

    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _spmLog2.default.info('reduce task', 'picking the best translation');
            /*
            result: [{
              id: 'totalPrice',
              description: '展示订单总额',
              defaultMessage: '订单全额',
              cn: {'The order in full - from google': 'The order in full'},
              en: {'The order in full - from google': 'The order in full'},
            }, {
              id: 'totalPrices',
              description: '展示订单总额',
              defaultMessage: '订单全额',
              cn: {'The order in full - from google': 'The order in full'},
              en: {'The order in full - from google': 'The order in full'},
            }];
            */

            pickResource = result;
            _autoPick$query = _extends({
              autoPick: 'local'
            }, query);
            autoPick = _autoPick$query.autoPick;
            local = _autoPick$query.local;
            select = context.select;
            isObject = context.isObject;
            maxKeys = context.maxKeys;


            if (local) {
              file = maxKeys(result).reduce(function (collect, lang) {
                return _extends({}, collect, _defineProperty({}, lang, exists((0, _path.join)(context.cwd, local, lang)) ? require((0, _path.join)(context.cwd, local, lang)) : {}));
              }, {});

              pickResource = fetchLocal(result, file, autoPick);
            }

            _iteratorNormalCompletion = true;
            _didIteratorError = false;
            _iteratorError = undefined;
            _context.prev = 12;
            _iterator = pickResource[Symbol.iterator]();

          case 14:
            if (_iteratorNormalCompletion = (_step = _iterator.next()).done) {
              _context.next = 49;
              break;
            }

            item = _step.value;
            langs = Object.keys(item);
            _iteratorNormalCompletion2 = true;
            _didIteratorError2 = false;
            _iteratorError2 = undefined;
            _context.prev = 20;
            _iterator2 = langs[Symbol.iterator]();

          case 22:
            if (_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done) {
              _context.next = 32;
              break;
            }

            lang = _step2.value;

            if (!isObject(item[lang])) {
              _context.next = 29;
              break;
            }

            _spmLog2.default.warn('picking best translation', item.id);
            _context.next = 28;
            return select(item[lang], 'picking ' + lang);

          case 28:
            item[lang] = _context.sent;

          case 29:
            _iteratorNormalCompletion2 = true;
            _context.next = 22;
            break;

          case 32:
            _context.next = 38;
            break;

          case 34:
            _context.prev = 34;
            _context.t0 = _context['catch'](20);
            _didIteratorError2 = true;
            _iteratorError2 = _context.t0;

          case 38:
            _context.prev = 38;
            _context.prev = 39;

            if (!_iteratorNormalCompletion2 && _iterator2.return) {
              _iterator2.return();
            }

          case 41:
            _context.prev = 41;

            if (!_didIteratorError2) {
              _context.next = 44;
              break;
            }

            throw _iteratorError2;

          case 44:
            return _context.finish(41);

          case 45:
            return _context.finish(38);

          case 46:
            _iteratorNormalCompletion = true;
            _context.next = 14;
            break;

          case 49:
            _context.next = 55;
            break;

          case 51:
            _context.prev = 51;
            _context.t1 = _context['catch'](12);
            _didIteratorError = true;
            _iteratorError = _context.t1;

          case 55:
            _context.prev = 55;
            _context.prev = 56;

            if (!_iteratorNormalCompletion && _iterator.return) {
              _iterator.return();
            }

          case 58:
            _context.prev = 58;

            if (!_didIteratorError) {
              _context.next = 61;
              break;
            }

            throw _iteratorError;

          case 61:
            return _context.finish(58);

          case 62:
            return _context.finish(55);

          case 63:
            return _context.abrupt('return', pickResource);

          case 64:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, this, [[12, 51, 55, 63], [20, 34, 38, 46], [39,, 41, 45], [56,, 58, 62]]);
  }));

  function pick(_x, _x2, _x3) {
    return ref.apply(this, arguments);
  }

  return pick;
}();

module.exports = exports['default'];