'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = save;

var _fs = require('fs');

var _spmLog = require('spm-log');

var _spmLog2 = _interopRequireDefault(_spmLog);

var _path = require('path');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function save(result, query, context) {
  _spmLog2.default.info('save task', 'saving result into json file');
  var maxKeys = context.maxKeys;
  var cwd = context.cwd;
  var arrayToObject = context.arrayToObject;
  var dest = query.dest;


  var langs = maxKeys(result);

  var saveResult = arrayToObject(langs.map(function (lang) {
    return {
      lang: lang,
      file: (0, _path.join)(cwd, dest, lang) + '.json',
      content: {}
    };
  }), 'lang');

  result.forEach(function (item) {
    langs.forEach(function (lang) {
      saveResult[lang].content[item.id] = item[lang];
    });
  });

  Object.keys(saveResult).forEach(function (item) {
    (0, _fs.writeFileSync)(saveResult[item].file, JSON.stringify(saveResult[item].content, null, 2));
  });
  return true;
}
module.exports = exports['default'];