'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

exports.default = translate;

require('babel-polyfill');

var _plugin = require('./plugin');

var _util = require('./util');

var utils = _interopRequireWildcard(_util);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function translate(options) {
  var cwd = options.cwd;
  var middleware = options.middleware;


  var context = _extends({}, utils, {
    cwd: cwd
  });
  context.set = function (key, val) {
    return context[key] = val;
  };
  context.get = function (key) {
    return context[key];
  };

  var resolveDir = [cwd];
  var pluginNames = Object.keys(middleware).reduce(function (a, b) {
    return a.concat(middleware[b]);
  }, []);

  var plugins = (0, _plugin.resolvePlugins)(pluginNames, resolveDir, cwd);

  plugins.reduce(function (a, b) {
    if (a instanceof Promise) {
      return a.then(function (result) {
        return b.plugin(result, b.query, context);
      });
    }
    return b.plugin(a, b.query, context);
  }, Promise.resolve());
}
module.exports = exports['default'];