'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.select = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var select = exports.select = function () {
  var ref = _asyncToGenerator(regeneratorRuntime.mark(function _callee(target) {
    var message = arguments.length <= 1 || arguments[1] === undefined ? 'pick the best one' : arguments[1];
    var answer;
    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _context.next = 2;
            return _inquirer2.default.prompt({
              name: 'value',
              type: 'list',
              message: message,
              choices: objectToArray(target, 'name')
            });

          case 2:
            answer = _context.sent;
            return _context.abrupt('return', answer.value);

          case 4:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, this);
  }));

  return function select(_x, _x2) {
    return ref.apply(this, arguments);
  };
}();

exports.arrayToObject = arrayToObject;
exports.objectToArray = objectToArray;
exports.isRelative = isRelative;
exports.isAbsolute = isAbsolute;
exports.isProvided = isProvided;
exports.isObject = isObject;
exports.format = format;
exports.maxKeys = maxKeys;

var _fs = require('fs');

var _path = require('path');

var _inquirer = require('inquirer');

var _inquirer2 = _interopRequireDefault(_inquirer);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { return step("next", value); }, function (err) { return step("throw", err); }); } } return step("next"); }); }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function arrayToObject(arr, key) {
  return arr.reduce(function (collection, current) {
    return _extends({}, collection, _defineProperty({}, current[key], _extends({}, current)));
  }, {});
}

function objectToArray(obj, key) {
  return Object.keys(obj).map(function (each) {
    return _defineProperty({
      value: obj[each]
    }, key, each);
  });
}

function isRelative(filepath) {
  return filepath.charAt(0) === '.';
}

function isAbsolute(filepath) {
  return filepath.charAt(0) === '/';
}

function isProvided(filepath) {
  return (0, _fs.existsSync)((0, _path.join)(__dirname, 'plugins', filepath + '.js'));
}

function isObject(something) {
  return something && something.constructor === Object;
}

function format(target, prefix) {
  var before = prefix || '';
  if (Array.isArray(target)) {
    return target.reduce(function (collection, item) {
      return _extends({}, collection, _defineProperty({}, item + ' - ' + before, item));
    }, {});
  } else if (isObject(target)) {
    return Object.keys(target).reduce(function (collection, key) {
      return _extends({}, collection, _defineProperty({}, target[key] + ' - ' + before + ' ' + key, target[key]));
    }, {});
  }
  return _defineProperty({}, target + ' - ' + before, target);
}

function maxKeys(arr) {
  return Object.keys(arr[0]);
}